package com.example.ecgsmartapp;

import java.io.File;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.PopupMenu;
import android.widget.TextView;
import android.widget.Toast;


public class Pag1 extends Activity {

	public Button button_lead;
	public Button button_save;
	public Button button_help;
	public TextView text_lead;	
	public Button button_notch50or60;
	public TextView text_notch50or60;
	public Button button_saveDataFiltered;
	public TextView text_saveDataFiltered;	
	public EditText edit_files_folder;
	public TextView text_files_folder;
	public EditText edit_gain_coeff;
	public TextView text_gain_coeff;	
	public Intent intent1=new Intent();	
	
	public int lead; 
	public int gain_coeff; 
	public int notch50or60; 
	public int saveDataFiltered;
	public String files_folder="ECG_Files";
	public int already_pressed=0;	
	public File File_settings;
	private OutputStreamWriter outputStreamWriter_settings; 
	private FileOutputStream fOut_settings;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.pag1); 					
		Bundle extras = getIntent().getExtras(); 
		lead = extras.getInt("lead");
		gain_coeff = extras.getInt("gain_coeff");
		notch50or60 = extras.getInt("notch50or60");
		saveDataFiltered = extras.getInt("saveDataFiltered");			
	
		button_lead = (Button)findViewById(R.id.Button_lead);
		text_lead = (TextView)findViewById(R.id.text_view_lead);		
		button_notch50or60 = (Button)findViewById(R.id.Button_notch50or60);
		text_notch50or60 = (TextView)findViewById(R.id.text_view_notch50or60);
		button_saveDataFiltered = (Button)findViewById(R.id.Button_saveDataFiltered);
		text_saveDataFiltered = (TextView)findViewById(R.id.text_view_saveDataFiltered);	
		edit_files_folder = (EditText)findViewById(R.id.edit_files_folder);
		text_files_folder = (TextView)findViewById(R.id.text_view_files_folder);
		edit_gain_coeff = (EditText)findViewById(R.id.edit_gain_coeff);
		text_gain_coeff = (TextView)findViewById(R.id.text_view_gain_coeff);	
		button_save = (Button)findViewById(R.id.Button_save);
		button_help = (Button)findViewById(R.id.Button_help);
		
	    if (lead==1)
	        	text_lead.setText("LEAD I (LI) : Yellow on Left Arm - Red on Right Arm");
	         else
	        	 if (lead==2)
	        		text_lead.setText("LEAD II (LII) : Yellow on Left Leg - Red on Right Arm");
	        	 else
	        		 if (lead==3)
	        			text_lead.setText("LEAD III (LIII) : Yellow on Left Leg - Red on Left Arm");
	         	
		if (notch50or60 == 0)
			text_notch50or60.setText("  No Filter");	
		else
			text_notch50or60.setText("   " + String.valueOf(notch50or60) + "  Hz");	   
	   
		if (saveDataFiltered == 1)
			text_saveDataFiltered.setText("  Filtered");
		else
			text_saveDataFiltered.setText("  UnFiltered");

		
	    edit_files_folder.setText(files_folder);	      
	    edit_gain_coeff.setText(String.valueOf(gain_coeff));   
	    
	    
	    button_help.setOnClickListener(new View.OnClickListener()
		{
			 @Override
			 public void onClick(View v) {
		    	
				 try {
					 File help_file = new File(Environment.getExternalStorageDirectory() + "/" + files_folder,"help.pdf");//File path
			            if (help_file.exists()) //Checking for the file is exist or not
			            {
			                Uri path = Uri.fromFile(help_file);
			                Intent objIntent = new Intent(Intent.ACTION_VIEW);
			                objIntent.setDataAndType(path, "application/pdf");
			                objIntent.setFlags(Intent. FLAG_ACTIVITY_CLEAR_TOP);
			                startActivity(objIntent);//Staring the pdf viewer
			            } else {
			                Toast.makeText(getApplication(), "The file not exists! ", Toast.LENGTH_SHORT).show();
			            }
				 }
		         catch (Exception e) {
		        	 Toast.makeText(getApplication(), "App can not be open the file!", Toast.LENGTH_SHORT).show();	 
				 }
		 }});
	
	    
	    
	    
	    
	    
		button_lead.setOnClickListener(new View.OnClickListener()
		{
			 @Override
			 public void onClick(View v) {
				 
			 PopupMenu popup = new PopupMenu(Pag1.this, button_lead);  
			 //Inflating the Popup using xml file  
			 popup.getMenuInflater().inflate(R.menu.menu_leads, popup.getMenu());	
	
			 //registering popup with OnMenuItemClickListener  
			 popup.setOnMenuItemClickListener(new PopupMenu.OnMenuItemClickListener() {  
				  public boolean onMenuItemClick(MenuItem item) { 				 				  
					  switch (item.getItemId()) {
				        case R.id.LI:		        	
				        	lead=1;	
				        	text_lead.setText("LEAD I (LI) : Yellow on Left Arm - Red on Right Arm");
				        	break;		        	
				        case R.id.LII:
				        	lead=2;	        	
				        	text_lead.setText("LEAD II (LII) : Yellow on Left Leg - Red on Right Arm");
				        	break;  		        	
				        case R.id.LIII:
				        	lead=3;			        
				        	text_lead.setText("LEAD III (LIII) : Yellow on Left Leg - Red on Left Arm");
				        	break;		        			        	
				        default:		        	
				        	lead=1;											 
				        	text_lead.setText("LEAD I (LI) : Yellow on Left Arm - Red on Right Arm");
				        	break;
				    }			  			  		   
				   return true;  
				  }  
			 });  
			 popup.show();//showing popup menu
		 
		 }});
	
		 
		 button_notch50or60.setOnClickListener(new View.OnClickListener()
		 {
			 @Override
			 public void onClick(View v) {
			 PopupMenu popup = new PopupMenu(Pag1.this, button_notch50or60);  
			 //Inflating the Popup using xml file  
			 popup.getMenuInflater().inflate(R.menu.menu_notch, popup.getMenu());	
	
			 //registering popup with OnMenuItemClickListener  
			 popup.setOnMenuItemClickListener(new PopupMenu.OnMenuItemClickListener() {  
			  public boolean onMenuItemClick(MenuItem item) { 
			 				  			
				  switch (item.getItemId()) {
			        case R.id.notch50:		        	
			        	notch50or60=50;	
			        	text_notch50or60.setText("   " + String.valueOf(notch50or60) + "  Hz");
			        	break;		        	
			        case R.id.notch60:
			        	notch50or60=60;	        	
			        	text_notch50or60.setText("   " + String.valueOf(notch50or60) + "  Hz");
			        	break;  		     
			        case R.id.no_notch:
			        	notch50or60=0;	        	
			        	text_notch50or60.setText("  No Filter");
			        	break;  		     
			        default:		        	
			        	notch50or60=50;											 
			        	text_notch50or60.setText("   " + String.valueOf(notch50or60) + "  Hz");
			        	break;
			    }			  			  		   
			   return true;  
			  }  
			 });  
			 popup.show();//showing popup menu
		 }});
	

		 button_saveDataFiltered.setOnClickListener(new View.OnClickListener()
		 {
			 @Override
			 public void onClick(View v) {
	
			 PopupMenu popup = new PopupMenu(Pag1.this, button_saveDataFiltered);  
			 //Inflating the Popup using xml file  
			 popup.getMenuInflater().inflate(R.menu.menu_savedatafiltered, popup.getMenu());	
	
			 //registering popup with OnMenuItemClickListener  
			 popup.setOnMenuItemClickListener(new PopupMenu.OnMenuItemClickListener() {  
			 public boolean onMenuItemClick(MenuItem item) { 
			 				  			
				  switch (item.getItemId()) {
			        case R.id.savefilteredYes:		        	
			        	saveDataFiltered=1;	
			        	text_saveDataFiltered.setText("  Filtered");
			        	break;		        	
			        case R.id.savefilteredNo:
			        	saveDataFiltered=0;	        	
			        	text_saveDataFiltered.setText("  UnFiltered");
			        	break;  		     		     
			        default:		        	
			        	saveDataFiltered=1;											 
			        	text_saveDataFiltered.setText("  Filtered");
			        	break;
			    }			  			  		   
			   return true;  
			  }  
			 });  
			 popup.show();//showing popup menu
		 }});
	
			 
		 
		 button_save.setOnClickListener(new View.OnClickListener()
		 {
			 @Override
			 public void onClick(View v) {
		
					int control_gain=0;
					if (edit_gain_coeff.getText().toString().length()>0)
						try
						{
						 gain_coeff = Integer.parseInt(edit_gain_coeff.getText().toString());
						 control_gain=1;
						}	
						catch (NumberFormatException n)
						{				
							Toast.makeText(getApplication()," GAIN must be an integer > 0 ", Toast.LENGTH_LONG).show();
							control_gain=0;
						}
					else
					{Toast.makeText(getApplication()," Please insert a GAIN value (an integer > 0) ", Toast.LENGTH_LONG).show();
						control_gain=0;
					}
													
					if (control_gain==1)
					{							
					   intent1.putExtra("lead", lead);
				       intent1.putExtra("gain_coeff", gain_coeff);
				       intent1.putExtra("notch50or60", notch50or60);
				       intent1.putExtra("saveDataFiltered", saveDataFiltered);	   
					   
				       // write a txt file in internal storage named "Settings.txt"				       
				       String string_notch50or60;
				       if (notch50or60==0)
				    	   string_notch50or60="00";
				       else
				    	   string_notch50or60=String.valueOf(notch50or60); 
				       
					try {
							String data= String.valueOf(lead) + " "  + string_notch50or60 +
									" "  + String.valueOf(saveDataFiltered)+ " " + String.valueOf(gain_coeff);
						
							File dir = getFilesDir ();
						    dir.mkdirs();
						    //create a standard java.io.File object for the Workbook to use
						    File_settings = new File(dir,"Settings.txt");
						    File_settings.createNewFile();
					    	fOut_settings = new FileOutputStream(File_settings);
					    	outputStreamWriter_settings = new OutputStreamWriter(fOut_settings);					    	
					    	outputStreamWriter_settings.write(data);
					    	outputStreamWriter_settings.close();						
					    	Toast.makeText(getApplication(), "Settings saved!", Toast.LENGTH_LONG).show();
						
						} catch (IOException e) {						
						Toast.makeText(getApplication(),"Impossible to save the settings!", Toast.LENGTH_LONG).show();				
						}
		  
					setResult(101,intent1);					
					Pag1.this.finish();
					}
			 }});
		 
	}
	
	
	@Override
	public void onBackPressed() {
		
		setResult(101,intent1);
		finish();
		return;			
	}
	
	

	
	}